<?

/*
      kontakt-filter.php f&uuml;r PHP Magazin Demos
      
      Aufgabe:
      	Kontaktformular
      
		Benutzte Variablen:
			Aufruf:
           aktion   ggf. durchzuf&uuml;hrende Aktion
           subject  ggf. das Subject der Mail
           from     ggf. der Absender der Mail
           body     ggf. der Inhalt der Mail


 */

// Der Mail-Empf&auml;nger
define ("MAILTO","kontaktformular@anwendung.example");

// Werte &uuml;bernehmen
$aktion  = $_POST["aktion"];
$subject = urldecode($_POST["subject"]);
$from    = urldecode($_POST["from"]);
$body    = urldecode($_POST["body"]);

// urldecode(), da die $_POST-Variable nicht automatisch
// dekodiert wird

// CR und LF-Zeichen aus dem $from l&ouml;schen
$from = str_replace("\r","",$from);
$from = str_replace("\n","",$from);

// XSS verhindern:
$subject = htmlentities(strip_tags($subject));
$from    = htmlentities(strip_tags($from));
$body    = htmlentities(strip_tags($body));


?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>PHP Magazin Demos - Kontaktformular mit Filter</title>
</head>

<body>

<h1>PHP Magazin Demos - Kontaktformular mit Filter</h1>

<?

if ($aktion == "Absenden") {
   // Mail absenden
   if ($from != "") {
      // Ein Absender ist vorhanden
      $fromheader = "From: ".$from;
      if ( mail(MAILTO, $subject, $body, $fromheader) ) {
         echo "<p><b>Die Absender-Adresse wurde ggf. bereinigt, die Mail wurde gesendet!</b></p> \n";
         $from = "";
         $subject = "";
         $body = "";
      } else {
         echo "<p><b>Fehler beim Senden der Mail!</b></p> \n";
      }
   } else {
      // Wem sollen wir antworten, wenn kein Absender angegeben wurde?
      echo "<p><b>Bitte geben Sie ihre E-Mail-Adresse als Absender an, damit wir Ihnen antworten k&ouml;nnen! <br> \n";
      echo "Danke!</b></p> \n";
   }
} else if ($aktion == "Simulieren") {
   // Mail in Datei schreiben
   if ($from != "") {
      // Ein Absender ist vorhanden
      $fromheader = "From: ".$from;

      $mail = "";
      $mail = $mail."To: ".MAILTO."\r\n";
      $mail = $mail."Subject: ".$subject."\r\n";
      $mail = $mail.$fromheader."\r\n";
      $mail = $mail."\r\n";
      $mail = $mail.$body."\r\n";
 
      file_put_contents("mail.txt", $mail);
   } else {
      // Wem sollen wir antworten, wenn kein Absender angegeben wurde?
      echo "<p><b>Bitte geben Sie ihre E-Mail-Adresse als Absender an, damit wir Ihnen antworten k&ouml;nnen! <br> \n";
      echo "Danke!</b></p> \n";
   }
}



?>

<form action="kontakt-filter.php" method="POST"> 
   Ihre E-Mail-Adresse: <br> 
   <input type="text" name="from" value="<? echo $from; ?>" size="50">   <br>
   Das Subject: <br> 
   <input type="text" name="subject" value="<? echo $subject; ?>" size="50">   <br>
   Der Text: <br>
   <textarea rows="20" cols="70" name="body"><? echo $body; ?></textarea> <br>
   <input type="reset" value="Reset">
   <input type="submit" name="aktion" value="Simulieren">
   <input type="submit" name="aktion" value="Absenden">
</form>

<?

if ($aktion == "Simulieren") {
  // Es wurde eine Datei mail.txt geschrieben, diese anzeigen
  $mailtext = file_get_contents("mail.txt");
  echo "<h2>Die erzeugte Mail:</h2> \n";
  echo "<pre>".$mailtext."</pre> \n";

  file_put_contents("mail.txt", "");
}

?>

</body>
</html>